import os
import re
import numpy as np
import cv2
import imutils 
from os.path import isfile, join

kernel = np.ones((4,4),np.uint8)
font = cv2.FONT_HERSHEY_SIMPLEX
col_images= cv2.imread("test.png")
diff_image = cv2.cvtColor(col_images , cv2.COLOR_BGR2GRAY)

otsu_threshold, image_result = cv2.threshold(diff_image, 0, 255, cv2.THRESH_BINARY + cv2.THRESH_OTSU)
image_result = cv2.medianBlur(image_result,3)

image_result = cv2.morphologyEx(image_result, cv2.MORPH_CLOSE, np.ones([8, 8]))
#image_result = cv2.morphologyEx(image_result, cv2.MORPH_OPEN, np.ones([5, 5]))

cnts = cv2.findContours(image_result.copy(), cv2.RETR_EXTERNAL,cv2.CHAIN_APPROX_SIMPLE)
cnts = imutils.grab_contours(cnts)
cX, cY = 0, 0

for c in cnts:
    M = cv2.moments(c)

    if M["m00"] != 0:
        cX = int(M["m10"] / (M["m00"]))
        cY = int(M["m01"] / (M["m00"]))

    cv2.drawContours(col_images, [c], -1, (0, 0, 255), 1)
    cv2.circle(col_images, (cX, cY), 1, (255, 0, 0), -1)

count, comp = cv2.connectedComponents(image_result)

text = "Count: " + str(count - 1)
print(text)